// code by jph
package kah;

import java.util.LinkedList;
import java.util.List;
import java.util.stream.IntStream;

import kah.mov.Move;
import kah.mov.UserMove;
import sys.IntRange;

public class Explore {
  final int flips;
  List<Move> myLeafs = new LinkedList<>();

  public Explore(Move myRoot, int flips) {
    this.flips = flips;
    buildRecursive(myRoot);
  }

  private void buildRecursive(Move move) {
    if (move instanceof UserMove && flips <= move.flips) {
      assert flips == move.flips;
      // leaf condition; do nothing
      myLeafs.add(move);
    } else {
      // loop over all pits with stones
      IntStream intStream = new IntRange(6).stream().filter(move.board::hasStones);
      // if (parallel) { // TODO
//      if (!intStream.isParallel()) {
        // assert !intStream.isParallel();
//        intStream.parallel();
//      }
      intStream.forEach(pos -> buildRecursive(move.nextMove(pos)));
      if (move.board.isMoveTerminal())
        buildRecursive(move.nextMoveTerminal());
    }
  }
}
