// code by jph
package kah.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;
import javax.swing.WindowConstants;

import kah.Kalaha;
import kah.var.Variant;
import sys.IntRange;
import sys.gui.SpinnerLabel;

/**
 * Link to high quality online game engine:
 * http://kalaha.krus.dk/
 * http://kalaha.krus.dk/play/
 */
public class KalahaGui {
  private final int HEIGHT = 28;
  JFrame myJFrame = new JFrame();
  final int stones = 6;
  final Variant variant = Variant.Standard;
  final boolean user = true;

  public KalahaGui() {
    myJFrame.setTitle("Kalaha ");
    myJFrame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    JPanel myJPanel = new JPanel(new BorderLayout());
    JToolBar myJToolBar = new JToolBar();
    myJToolBar.setLayout(new FlowLayout(FlowLayout.LEFT, 3, 0));
    myJToolBar.setFloatable(false);
    KalahaComponent kalahaComponent = new KalahaComponent();
    kalahaComponent.setKalaha(new Kalaha(stones, variant.getRules(), user));
    {
      SpinnerLabel<Variant> mySpinnerLabelVariant = new SpinnerLabel<>();
      mySpinnerLabelVariant.setArray(Variant.values());
      mySpinnerLabelVariant.setValue(variant);
      mySpinnerLabelVariant.addToComponentReduced(myJToolBar, new Dimension(120, HEIGHT), "game variant");
      myJToolBar.addSeparator();
      // ---
      myJToolBar.add(new JLabel("Stones"));
      SpinnerLabel<Integer> mySpinnerLabelStones = new SpinnerLabel<>();
      mySpinnerLabelStones.setList(new IntRange(2, 9).toList());
      mySpinnerLabelStones.setValue(stones);
      mySpinnerLabelStones.addToComponentReduced(myJToolBar, new Dimension(30, HEIGHT), "initial stones");
      myJToolBar.addSeparator();
      // ---
      myJToolBar.add(new JLabel("First"));
      SpinnerLabel<String> mySpinnerLabelFirst = new SpinnerLabel<>();
      mySpinnerLabelFirst.setArray("user", "self");
      mySpinnerLabelFirst.setValue(user ? "user" : "self");
      mySpinnerLabelFirst.addToComponentReduced(myJToolBar, new Dimension(60, HEIGHT), "first move");
      myJToolBar.addSeparator();
      // ---
      {
        JToggleButton myJToggleButton = new JToggleButton("hints");
        myJToggleButton.addActionListener( //
            myActionEvent -> kalahaComponent.setDisplayHint(myJToggleButton.isSelected()));
        myJToggleButton.setToolTipText("display hints for user");
        myJToolBar.add(myJToggleButton);
        myJToolBar.addSeparator();
      }
      // ---
      {
        JButton myJButton = new JButton("reset");
        myJButton.setToolTipText("reset game");
        myJButton.addActionListener(myActionEvent -> {
          kalahaComponent.setKalaha(new Kalaha( //
              mySpinnerLabelStones.getValue(), //
              mySpinnerLabelVariant.getValue().getRules(), //
              mySpinnerLabelFirst.getValue().equals("user")));
        });
        myJToolBar.add(myJButton);
      }
      myJToolBar.addSeparator();
      // ---
      myJToolBar.add(new JLabel("Limits"));
      SpinnerLabel<Integer> mySpinnerLabelFlips = new SpinnerLabel<>();
      mySpinnerLabelFlips.setArray(2, 4, 6, 8, 10, 12, 14);
      mySpinnerLabelFlips.setValue(kalahaComponent.flips);
      mySpinnerLabelFlips.addSpinnerListener(flips -> kalahaComponent.flips = flips);
      mySpinnerLabelFlips.addToComponentReduced(myJToolBar, new Dimension(30, HEIGHT), "flips");
      // ---
    }
    myJPanel.add("North", myJToolBar);
    myJPanel.add("Center", kalahaComponent.myJComponent);
    myJFrame.setContentPane(myJPanel);
    myJFrame.setBounds(100, 100, 640, 300);
    myJFrame.setResizable(false);
  }

  public static void main(String[] args) {
    KalahaGui myMapWindow = new KalahaGui();
    myMapWindow.myJFrame.setVisible(true);
  }
}
