// code by jph
package kah.mov;

import kah.Board;

/**
 * move by computer  
 */
class SelfMove extends Move {
  SelfMove(Board board, int depth, int flips) {
    super(board, depth, flips);
  }

  @Override
  public int minimax() {
    return map.values().stream() //
        .mapToInt(Move::minimax) //
        .min() // MINIMUM
        .getAsInt();
  }

  @Override
  public Move nextMove(int pos) {
    boolean again = board.isMoveAgain(pos);
    Board next = board.move(pos);
    return protected_child(pos, again ? new SelfMove(next, depth + 1, flips) : new UserMove(next.flip(), depth + 1, flips + 1));
  }

  @Override
  public Move nextMoveTerminal() {
    return protected_child(TERMINAL_KEY, new UserMove(board.moveTerminal().flip(), depth + 1, flips + 1));
  }
}
