// code by jph
package kah.mov;

import kah.Board;

/**
 * move by human, i.e. opponent of computer 
 */
public class UserMove extends Move {
  public UserMove(Board board, int depth, int flips) {
    super(board, depth, flips);
  }

  @Override
  public int minimax() {
    return map.isEmpty() ? board.evaluate()
        : map.values().stream() //
            .mapToInt(Move::minimax) //
            .max() // MAXIMUM
            .getAsInt();
  }

  @Override
  public Move nextMove(int pos) {
    boolean again = board.isMoveAgain(pos);
    Board next = board.move(pos);
    return protected_child(pos, again ? new UserMove(next, depth + 1, flips) : new SelfMove(next.flip(), depth + 1, flips + 1));
  }

  @Override
  public Move nextMoveTerminal() {
    return protected_child(TERMINAL_KEY, new SelfMove(board.moveTerminal().flip(), depth + 1, flips + 1));
  }
}
